on 1:START: {
  set %wecrm.ini $scriptdir $+ wecrm.dat
  set %wecrm.running $getsel_wecrm(wecRM AUTOSTART)
  set %wecrm.nukelogging $getsel_wecrm(nukeM nLogging)
  loadwecrm
  halt_wecrm
}

alias testwecrm {
  return 0
}

alias getsel_wecrm {
  set %wecrm.gt.getsel $readini %wecrm.ini $gettok($1,1,32) $gettok($1,2,32)
  set %wecrm.gt.getsel $gettok(%wecrm.gt.getsel,1,32)
  return %wecrm.gt.getsel
}

alias wecrmprefix { return %wecrm.cp }

;###[ FUNCTIONS WICH CALL CHANGE TOGGLE SETTINGS ]###
alias wautostart { $toggle(WECRM,AUTOSTART,$1) }
alias wknowngrp { $toggle(WECRM,KNOWNGROUPSONLY,$1) }
alias wautoclipboard { $toggle(WECRM,AUTOCLIPBOARD,$1) }
alias wbeep { $toggle(WECRM,BEEP,$1) }
alias wnoracemode { $toggle(WECRM,NORACEMODE,$1) }
alias wndispmode { $toggle(nukeM,NDISPMODE,$1) }
alias wnoind { $toggle(WECRM,NOINDEPENDENT,$1) }
alias wnlog { $toggle(nukeM,nLogging,$1) }
alias wnstartup { $toggle(nukeM,nWindowOnStartup,$1) }
alias wmp3mode { $toggle(wecRM,MP3mode,$1) }

;###[ FUNCTIONS WICH USE CVLSET/VIEW
alias wbanstring { cvlset $SCRIPTDIRwecrm.dat BANNED $1 }
alias wreqstring { cvlset $SCRIPTDIRwecrm.dat REQUIRED $1 }
alias wsitename { cvlset $SCRIPTDIRwecrm.dat SITENAMES $1 }
alias wpresites { cvlset $SCRIPTDIRpresites.dat PRESITES $1 }

alias wlistbanstring { cvlview $SCRIPTDIRwecrm.dat BANNED }
alias wlistreqstring { cvlview $SCRIPTDIRwecrm.dat REQUIRED }
alias wlistpresites { cvlview $SCRIPTDIRpresites.dat PRESITES }
alias wlistsitenames { cvlview $SCRIPTDIRwecrm.dat SITENAMES }

alias wecrm_runcheck {
  if ( $chr(32) isin %wecrm.ini ) { echo -a : Install in a dir without spaces - wecRM UNLOADED | goto finish_abort_wecrm }
  if ( $version < 5.71 ) { echo -a : Get mirc 5.71 or newer - wecRM UNLOADED | goto finish_abort_wecrm }
  goto getoutofhere_wecrm
  :finish_abort_wecrm
  unload -rs wecrm.mrc
  .timer 1 0 unload -rs wecrm-part2.mrc
  unset %wecrm.*
  unset %wr.*
  halt
  :getoutofhere_wecrm
}

;###[ RUNS WHEN LOADING SCRIPT SHOULD BE CHECKED NOT WORKING NOW ]###
alias loadwecrm {
  setcriticalvariables_wecrm
  .ddeserver off
  if (%wecrm.ddemode == yes) $wecrm_initdde(start)

  echo -s ---////-//--- wecRM cool equipment for cool ppl!
  echo -s :
  echo -s : buildno %wecrm.version ( $+ $calc($ASCTIME(yymmdd) - %wecrm.version ) days old)
  echo -s :

  wecrm_runcheck

  if ( $exists( %wecrm.dupedb ) == $false ) { write %wecrm.dupedb [RLSNAMES] | echo -s : No dupeDB, created. }
  if ( $exists( %wecrm.nukedb ) == $false ) { write %wecrm.nukedb [NUKELIST] | echo -s : No nukeDB, created. }
  set %wecrm.lwrm.tmp $SCRIPTDIR $+ NUKEBASE
  if ( $exists( %wecrm.lwrm.tmp ) == $false ) {
    mkdir %wecrm.lwrm.tmp
    echo -s : No NUKEBASE directory, created.
    .remove %wecrm.nukedb
    write %wecrm.nukedb [NUKELIST]
  }

  wecrm_cleandbs

  if ( %wecrm.running == yes ) { display INIT_WECRM | if ( %wecrm.noracemode == no ) display INIT_RACEMODE_WECRM | set %wecrm.running yes }
  if ( %wecrm.nukelogging == yes ) { set %wecrm.nukelogging yes | display INIT_nukeM | if ( $getsel_wecrm(nukeM nWindowOnStartup) == yes ) && ( %wecrm.nukemonrunning == no ) initnukewindow }

  echo -s :
  echo -s : Current status,
  echo -s : . . .. running: %wecrm.running
  echo -s : .. nukelogging: %wecrm.nukelogging
  echo -s : . . .. mp3mode: %wecrm.mp3mode
  if (%wecrm.ddemode == yes) $wecrm_ddestatus(start)
  else echo -s : . .. . ddemode: %wecrm.ddemode
  echo -s :
  echo -s : Send bugreports and requests to wector@housemusic.com
  echo -s : Please look at bottom of wecrmdoc.txt before sending one.
  echo -s :
  echo -s -------------------------------------------//-/////--------

  .timer 1 3 { .reload -rs $scriptdir $+ wecrm.mrc }
  .timer 1 3 { .reload -rs $SCRIPTDIRwecrm-part2.mrc }

  unset %wecrm.lwrm*
  unset %wecrm.gt.lwrm*
}

alias checkini_wecrm {
   set %wecrm.ci.ini $SCRIPTDIRwecrmdat. $+ %wecrm.version
   set %wecrm.ci.topics $ini(%wecrm.ci.ini,0)
   set %wecrm.ci.tl 1
   while (%wecrm.ci.tl <= %wecrm.ci.topics) {
      set %wecrm.ci.topic $ini(%wecrm.ci.ini,%wecrm.ci.tl)
      set %wecrm.ci.items $ini(%wecrm.ci.ini,%wecrm.ci.tl,0)
      set %wecrm.ci.il 1
      while (%wecrm.ci.il <= %wecrm.ci.items) {
         set %wecrm.ci.item $ini(%wecrm.ci.ini,%wecrm.ci.tl,%wecrm.ci.il)
         set %wecrm.ci.setting $readini -n %wecrm.ci.ini %wecrm.ci.topic %wecrm.ci.item
         if ($readini -n %wecrm.ini %wecrm.ci.topic %wecrm.ci.item == $null) {
            if ($left(%wecrm.ci.setting,1) == ) set %wecrm.ci.setting $right(%wecrm.ci.setting,$calc($len(%wecrm.ci.setting) -1))
            writeini %wecrm.ini %wecrm.ci.topic %wecrm.ci.item $replace(%wecrm.ci.setting,,%)
         }
         elseif ($left(%wecrm.ci.setting,1) == ) {
            set %wecrm.ci.setting $gettok($readini %wecrm.ini %wecrm.ci.topic %wecrm.ci.item,1,32) $gettok(%wecrm.ci.setting,2-,32)
            set %wecrm.ci.tmps $readini %wecrm.ini %wecrm.ci.topic %wecrm.ci.item
            set %wecrm.ci.tmps $gettok(%wecrm.ci.tmps,1,32)
            set %wecrm.ci.setting %wecrm.ci.tmps %wecrm.ci.setting
            writeini %wecrm.ini %wecrm.ci.topic %wecrm.ci.item $replace(%wecrm.ci.setting,,%)
         }
         inc %wecrm.ci.il
      }
      inc %wecrm.ci.tl
   }
   if (%wecrm.ci.setting != $null) echo -a $wecrmprefix New settings have been transfered to wecrm.dat
   unset %wecrm.ci.*
}
   
alias setcriticalvariables_wecrm {
  set %wecrm.version 001113
  checkini_wecrm

  set %wr.b 
  set %wr.uk 
  set %wr.0 0
  set %wr.1 1
  set %wr.2 2
  set %wr.3 3
  set %wr.4 4
  set %wr.5 5
  set %wr.6 6
  set %wr.7 7
  set %wr.8 8
  set %wr.9 9
  set %wr.10 10
  set %wr.11 11
  set %wr.12 12
  set %wr.13 13
  set %wr.14 14
  set %wr.15 15

  set %wecrm.ini $scriptdir $+ wecrm.dat
  set %wecrm.dupedb $SCRIPTDIRreleasedb.txt
  set %wecrm.nukedb $SCRIPTDIRnukedb.txt

  set %wecrm.autocopy $getsel_wecrm(wecRM Autoclipboard)
  if ( %wecrm.autocopy == xwork ) set %wecrm.autocopy x
  if (%wecrm.noracemode == yes) && ($getsel_wecrm(wecRM noracemode) == no) display INIT_RACEMODE_WECRM
  set %wecrm.noracemode $getsel_wecrm(wecRM NoRaceMode)
  set %wecrm.beep $getsel_wecrm(wecRM Beep)
  set %wecrm.lkgrp $readini %wecrm.ini WECRM lKnowngrp
  set %wecrm.lukgrp $readini %wecrm.ini WECRM lUnknowngrp
  set %wecrm.cp $readini %wecrm.ini WECRM CleanPrefix
  set %wecrm.noind $getsel_wecrm(wecRM NoIndependent)
  set %wecrm.knowngrpsonly $getsel_wecrm(wecRM KnownGroupsOnly)
  if ( %wecrm.nukemonrunning == yes ) set %wecrm.nukelogging yes
  else set %wecrm.nukelogging $getsel_wecrm(nukeM nLogging)
  set %wr.h $readini %wecrm.ini wecRM highlight
  set %wr.uh $readini %wecrm.ini wecRM unhighlight
  set %wecrm.mp3mode $getsel_wecrm(wecRM MP3mode)
  set %wecrm.timex $readini %wecrm.ini wecrm xtime
  set %wecrm.timeoutx $readini %wecrm.ini wecrm xtimeout
  set %wecrm.ddemode $getsel_wecrm(wecrm DDEmode)
  if ($getsel_wecrm(wecrm autoclipboard) == X) { set %wecrm.xwinmode $readini %wecrm.ini wecrm xmodewin | set %wecrm.xwork false }
  else { set %wecrm.xwinmode $readini %wecrm.ini wecrm xmodeworkwin | set %wecrm.xwork true }
  set %wecrm.dirname wecRM.trying.to.prevent.awful.bugs-HAHAHA
  set %wecrm.lastdirname wecRM.is.still.trying.to.prevent.awful.bugs-HAHAHA
  set %wecrm.olddirname wecRM.does.nothing.but.prevent.awful.bugs-HAHAHA
  set %wecrm.jumpbotchan $getsel_wecrm(wecRM JumpBotChan)

  if (%wecrm.gt.reload == yes) echo -a $wecRMprefix Reload finished.
  unset %wecrm.gt.reload
 
}

alias wecrm_initdde {
      if ( $isdde(wra) != $true ) {
         .ddeserver on wra
         set %wecrm.ddename wrb
      }
      elseif ( $isdde(wrb) != $true ) {
         .ddeserver on wrb
         set %wecrm.ddename wra
      }
      else {
         if ($1 != start) {
            echo -a $wecrmprefix Could not initialize DDEmode! Seems you allready got 2 Mirc communicating.
            wecrm_ddestatus
         }
      }
}

alias wecrm_ddestatus {
   set %wecrm.gt.wra $dde wra server ""
   set %wecrm.gt.wra %wecrm.gt.wra $iif(%wecrm.gt.wra == $null,not connected)

   set %wecrm.gt.wrb $dde wrb server ""
   set %wecrm.gt.wrb %wecrm.gt.wrb $iif(%wecrm.gt.wrb == $null,not connected)

   set %wecrm.gt.wranick $dde wra nickname ""
   set %wecrm.gt.wranick %wecrm.gt.wranick $iif(%wecrm.gt.wranick == $null,nothing)

   set %wecrm.gt.wrbnick $dde wrb nickname ""
   set %wecrm.gt.wrbnick %wecrm.gt.wrbnick $iif(%wecrm.gt.wrbnick == $null,nothing)

   if ($1 == start) {
      echo -s : . . .. ddemode: %wecrm.gt.wra as %wecrm.gt.wranick
      echo -s : . .. . ddemode: %wecrm.gt.wrb as %wecrm.gt.wrbnick
   }
   else {
      echo -a $wecrmprefix Working on %wecrm.gt.wra as %wecrm.gt.wranick
      echo -a $wecrmprefix Working on %wecrm.gt.wrb as %wecrm.gt.wrbnick
   }
}

alias wecrm_cleandbs {
  .timerwecrm_cleandb 00:01 0 86400 wecrm_cleandbs

  set %wecrm.lwrm.tmp $readini %wecrm.ini WECRM dupedb
  set %wecrm.lwrm.limitdate $calc( $ctime - (86400 * %wecrm.tmp ))
  set %wecrm.lwrm.looptimes $ini( %wecrm.dupedb ,RLSNAMES, 0)
  set %wecrm.lwrm.i 1
  set %wecrm.lwrm.c 0
  while ( %wecrm.lwrm.i <= %wecrm.lwrm.looptimes ) {
    set %wecrm.lwrm.tmp $ini( %wecrm.dupedb , RLSNAMES, %wecrm.lwrm.i )
    set %wecrm.lwrm.tmp2 $readini %wecrm.dupedb RLSNAMES %wecrm.lwrm.tmp
    if ( %wecrm.lwrm.limitdate < $gettok(%wecrm.lwrm.tmp2,1,32) ) { writeini $SCRIPTDIRreleasedb.tmp RLSNAMES %wecrm.lwrm.tmp %wecrm.lwrm.tmp2 }
    else { 
      inc %wecrm.lwrm.c
    }
    inc %wecrm.lwrm.i
  }
  set %wecrm.lwrm.tmp $scriptdir $+ releasedb.tmp
  if ( $exists( %wecrm.lwrm.tmp ) == $true ) {
    flushini $scriptdir $+ releasedb.tmp
    .copy -o $scriptdir $+ releasedb.tmp %wecrm.dupedb
    .remove $scriptdir $+ releasedb.tmp
  }
  elseif ( %wecrm.lwrm.c > 0 ) write -c %wecrm.dupedb [RLSNAMES]
  echo -s : Checking dupeDB, %wecrm.lwrm.c entrys removed $+ .

  set %wecrm.lwrm.tmp $readini %wecrm.ini nukeM nukedb
  set %wecrm.lwrm.limitdate $calc( $ctime - (86400 * %wecrm.lwrm.tmp ))
  set %wecrm.lwrm.looptimes $ini( %wecrm.nukedb ,NUKELIST, 0)
  set %wecrm.lwrm.i 1
  set %wecrm.lwrm.c 0
  while ( %wecrm.lwrm.i <= %wecrm.lwrm.looptimes ) {
    set %wecrm.lwrm.tmp $ini( %wecrm.nukedb , NUKELIST, %wecrm.lwrm.i )
    set %wecrm.lwrm.tmp2 $readini %wecrm.nukedb NUKELIST %wecrm.lwrm.tmp
    if ( %wecrm.lwrm.limitdate < $gettok(%wecrm.lwrm.tmp2,1,32) ) { writeini $scriptdir $+ nukelist.tmp NUKELIST %wecrm.lwrm.tmp %wecrm.lwrm.tmp2 }
    else { 
      .remove $scriptdir $+ nukebase\ $+ %wecrm.lwrm.tmp
      .remove $scriptdir $+ nukebase\ $+ %wecrm.lwrm.tmp $+ [ .uc ]
      inc %wecrm.lwrm.c
    }
    inc %wecrm.lwrm.i
  }
  set %wecrm.lwrm.tmp $scriptdir $+ nukelist.tmp
  if ( $exists( $SCRIPTDIRnukelist.tmp ) == $true ) {
    flushini $scriptdir $+ nukelist.tmp
    .copy -o $scriptdir $+ nukelist.tmp %wecrm.nukedb
    .remove $scriptdir $+ nukelist.tmp
  }
  elseif ( %wecrm.lwrm.c > 0 ) write -c %wecrm.nukedb [NUKELIST]
  echo -s : Checking nukeDB, %wecrm.lwrm.c entrys removed $+ .

  unset %wecrm.lwrm*
  unset %wecrm.gt.lwrm*

}

menu nicklist {
  wecRM
  .Add:{ .auser -a echobot $$1 | echo -a $wecrmprefix $$1 is now added as echobot }
  .EditSitename: wsitename $$1
  .StartIgnore:{ set %wecrm.gt.si $?="Enter start ignore char (Nothing but enter removes old setting)" | writeini $SCRIPTDIRbots.dat StartIgnore $$1 %wecrm.gt.si }
  .EndIgnore:{ set %wecrm.gt.ei $?="Enter end ignore char (Nothing but enter removes old setting)" | writeini $SCRIPTDIRbots.dat EndIgnore $$1 %wecrm.gt.ei }
  .Rem:{ .ruser echobot $$1 | echo -a $wecrmprefix $$1 is now removed from echobot list }
}

menu query,status,channel {
  wecRM
  .Help: wecrmhelp
  .Nukemonitor:{
    wecrm_runcheck
    initnukewindow
    if ($getsel_wecrm(nukeM nLogging) == NO) && ($getsel_wecrm(NOTE nukelogging) != YES) {
      dialog -m nukemonitornote nukemonitornote
      $toggle(NOTE,nukelogging,yes)
    }
  }
  .-
  .Window clean:{ .filter -wfcx $active ~filter.tmp %wecrm.cp $+ [ * ] | .loadbuf -rp $active ~filter.tmp }
  .-
  .Configuration
  ..wecRM
  ...Autoclipboard ( $getsel_wecrm(wecrm autoclipboard) )
  ....Always: $toggle(wecrm,autoclipboard,always)
  ....Yes: $toggle(wecrm,autoclipboard,yes)
  ....X mode: $toggle(wecrm,autoclipboard,x)
  ....X work mode: $toggle(wecrm,autoclipboard,xwork)
  ....No: $toggle(wecrm,autoclipboard,no)
  ...Autostart ( $getsel_wecrm(wecRM AUTOSTART) )
  ....Yes: $toggle(wecrm,autostart,yes)
  ....No: $toggle(wecrm,autostart,no)
  ...Beep ( $getsel_wecrm(wecrm beep) )
  ....Yes: $toggle(wecrm,beep,yes)
  ....Wave/mp3/midi: $toggle(wecrm,beep,wave)
  ....No: $toggle(wecrm,beep,no)
  ...DDEmode ( $getsel_wecrm(wecrm DDEmode) ):
  ....Yes: $toggle(wecrm,ddemode,yes)
  ....No: $toggle(wecrm,ddemode,no)
  ...JumpBotChan ( $getsel_wecrm(wecRM JumpBotChan) )
  ....Yes: $toggle(wecrm,jumpbotchan,yes)
  ....No: $toggle(wecrm,jumpbotchan,no)
  ...Knowngroups Only ( $getsel_wecrm(wecrm knowngroupsonly) )
  ....Yes: $toggle(wecrm,knowngroupsonly,yes)
  ....No: $toggle(wecrm,knowngroupsonly,no)
  ...MP3 mode ( $getsel_wecrm(wecrm mp3mode) )
  ....Yes: $toggle(wecrm,mp3mode,yes)
  ....No: $toggle(wecrm,mp3mode,no)
  ...No independent ( $getsel_wecrm(wecrm noindependent) )
  ....Yes: $toggle(wecrm,noindependent,yes)
  ....No: $toggle(wecrm,noindependent,no)
  ...No Race Mode ( $getsel_wecrm(wecrm noracemode) )
  ....Yes: $toggle(wecrm,noracemode,yes)
  ....No: $toggle(wecrm,noracemode,no)
  ..nukeM
  ...Display mode ( $getsel_wecrm(nukeM nDispMode) )
  ....Detailed: $toggle(nukem,ndispmode,detailed)
  ....Nice: $toggle(nukem,ndispmode,nice)
  ...Logging ( $getsel_wecrm(nukeM nLogging) )
  ....Yes: $toggle(nukem,nLogging,yes)
  ....No: $toggle(nukem,nLogging,no)
  ...Window on startup ( $getsel_wecrm(nukeM nWindowOnStartup) )
  ....Yes: $toggle(nukem,nWindowOnStartup,yes)
  ....No: $toggle(nukem,nWindowOnStartup,no)
  .$iif(%wecrm.ddemode == yes,DDE MODE CONTROL)
  ..$iif(%wecrm.ddemode == yes,Status):wecrm_ddestatus
  ..$iif(%wecrm.ddemode == yes,Start):{ echo -a $wecrmprefix Starting DDEmode | wecrm_initdde }
  ..$iif(%wecrm.ddemode == yes,Stop):{ .ddeserver off | echo -a $wecrmprefix Stopped DDEmode }
  .$iif(%wecrm.running == no,START wecRM): { wecrm_runcheck | set %wecrm.running yes | loadwecrm }
  .-
  .Reload:wecrm_reload
  .Unload
  ..Unload:{
    unload -rs wecrm.mrc
    .timer 1 0 unload -rs wecrm-part2.mrc
  }
  .$iif(%wecrm.running == yes,STOP wecRM): { set %wecrm.running no }

}

alias wecrm_reload {
    .timer 1 10 setcriticalvariables_wecrm
    echo -a $wecRMprefix Reloading script..
    set %wecrm.gt.reload yes
    .timer 1 0 .reload -rs $SCRIPTDIRwecrm-part2.mrc
    .reload -rs $SCRIPTDIRwecrm.mrc
}

;**> DISPLAY HELP >****************
;==================================
alias wecrmhelp {
  window -ak0 @wecRM-HELP 30 20 680 400
  clear @wecRM-HELP
  aline @wecRM-HELP <    wecRM version %wecrm.version running on Mirc $version    >
  loadbuf @wecRM-HELP $scriptdir $+ [ wecrm.help ]
  sline @wecRM-HELP 20
}


;**> Detailed info >****************
;======================================
alias nDisplaydetailed {
  if (($window(@Nukelog-detailedinfo) == $null) || ($1 == New)) set %wecrm.nwd.disp $getsel_wecrm(nukeM nDispmode)
  elseif ( $window(@Nukelog-detailedinfo).title == Nice view mode ) set %wecrm.nwd.disp DETAILED
  else set %wecrm.nwd.disp NICE

  set %wecrm.gt.dispdet.ln $fline(@Nukemonitor,$sline(@Nukemonitor,1),1,0)
  if (%wecrm.gt.dispdet.ln < 3) halt
  if ((%wecrm.gt.dispdet.ln > 7) && (%wecrm.gt.dispdet.ln < 11)) halt
  if (%wecrm.gt.dispdet.ln < 11) dec %wecrm.gt.dispdet.ln 3
  else { 
    dec %wecrm.gt.dispdet.ln 6
    if (%wecrm.nonukes < 5) {
      dec %wecrm.gt.dispdet.ln $calc(5 - %wecrm.nonukes)
    }
  }
  set %wecrm.gt.dispdet.ln $calc( $ini( %wecrm.nukedb , NUKELIST , 0 ) -%wecrm.gt.dispdet.ln )
  set %wecrm.nukedbname1 $ini( %wecrm.nukedb , NUKELIST , %wecrm.gt.dispdet.ln )
  set %wecrm.nukedbname $scriptdir $+ nukebase\ $+ %wecrm.nukedbname1

  set %wecrm.gt.dispdet.diw.coord $window(@Nukelog-detailedinfo).x $+ $chr(32) $+ $window(@Nukelog-detailedinfo).y $+ $chr(32) $+ $window(@Nukelog-detailedinfo).w $+ $chr(32) $+ $window(@Nukelog-detailedinfo).h

  window -c @Nukelog-detailedinfo
  if ( %wecrm.nwd.disp == DETAILED ) {
    set %wecrm.nukedbname %wecrm.nukedbname $+ [ .uc ]
    window -a @Nukelog-detailedinfo %wecrm.gt.dispdet.diw.coord
    titlebar @Nukelog-detailedinfo Unmodified nuke echo
  }
  else {
    window -al -t27 @Nukelog-detailedinfo %wecrm.gt.dispdet.diw.coord
    titlebar @Nukelog-detailedinfo Nice view mode
  }

  if ( $exists(%wecrm.nukedbname) == $true ) {
    setnukevariables %wecrm.nukedbname1
    loadbuf -re @Nukelog-detailedinfo $scriptdir $+ nukeheader.txt
    loadbuf -p @Nukelog-detailedinfo %wecrm.nukedbname
    if ( %wecrm.nwd.disp == NICE ) {
      loadbuf -e @Nukelog-detailedinfo $scriptdir $+ nukewindowseparator.txt
      sline @Nukelog-detailedinfo 1
    }
    else {
      loadbuf @Nukelog-detailedinfo $scriptdir $+ nukebottom.txt
      sline @Nukelog-detailedinfo 21
    }
    unset %wecrm.nukedbname*
  }
  unset %wecrm.nwd.*
}


menu @Nukemonitor {
  dclick:nDisplaydetailed New
}
menu @Nukelog-detailedinfo {
  rclick:nDisplaydetailed
}


;**> INIT NUKEVARIABLES <dirname> >***************
;=================================================
; NEW eller dirname
; NEW s plockar den massor frn ekot osv osv
; dirname enbart frn filer

alias setnukevariables {

  if ($1 == NEW) set %wecrm.n.dirname %wecrm.dirname
  else set %wecrm.n.dirname $1

  set %wecrm.n.dirinfo $readini %wecrm.nukedb NUKELIST %wecrm.n.dirname
  set %wecrm.n.reason $gettok(%wecrm.n.dirinfo,2,32)
  set %wecrm.n.sitereason $findreason(nReason)
  set %wecrm.n.nuker $findreason(nNuker)

  if ( %wecrm.n.dirinfo == $null ) {
    set %wecrm.n.reason %wecrm.n.sitereason
    set %wecrm.n.time $ctime
    set %wecrm.n.dirinfo %wecrm.n.time $+ $chr(32) $+ %wecrm.n.sitereason
  }
  elseif (( %wecrm.n.reason == unknown ) && ( $1 == NEW )) {
    set %wecrm.n.reason %wecrm.n.sitereason
    set %wecrm.n.dirinfo $gettok(%wecrm.n.dirinfo,1,32) $+ $chr(32) $+ %wecrm.n.reason $+ $chr(32) $+ $gettok(%wecrm.n.dirinfo,3-,32)
  }

  if ($1 == NEW) set %wecrm.n.dirinfo %wecrm.n.dirinfo $replace(%wecrm.d.sitename,$chr(32),_)

  ; DIRNAME=date(in seconds) reason sitename site_name 3rd_site_name ...
  set %wecrm.n.dateformat $readini %wecrm.ini nukeM ndateformat
  set %wecrm.n.date $asctime($gettok(%wecrm.n.dirinfo,1,32),%wecrm.n.dateformat)
  set %wecrm.n.timeformat $readini %wecrm.ini nukeM ntimeformat
  set %wecrm.n.time $asctime($gettok(%wecrm.n.dirinfo,1,32),%wecrm.n.timeformat)
  set %wecrm.n.ctime $gettok(%wecrm.n.dirinfo,1,32)
  set %wecrm.n.sites $gettok(%wecrm.n.dirinfo,3-,32)
  set %wecrm.n.numsites $numtok(%wecrm.n.sites,32)
  set %wecrm.n.sites $replace(%wecrm.n.sites,_,$chr(32))
}


;**> FIND REASON/NUKER ... >************
;=======================================
alias findreason {
  set %wecrm.gt.fr.tempc 1
  set %wecrm.gt.fr.searchword $readini %wecrm.ini nukeM $1
  set %wecrm.gt.fr.looptimes $numtok(%wecrm.gt.fr.searchword,32)

  while (%wecrm.gt.fr.tempc <= %wecrm.gt.fr.looptimes ) {
    set %wecrm.gt.fr.searchword $gettok(%wecrm.gt.fr.searchword,%wecrm.gt.fr.tempc,32)
    set %wecrm.gt.fr.i 0
    if ( $numtok(%wecrm.gt.fr.searchword,59) > 1 ) {
      set %wecrm.gt.fr.i $gettok(%wecrm.gt.fr.searchword,2,59)
      set %wecrm.gt.fr.searchword $gettok(%wecrm.gt.fr.searchword,1,59)
    }

    if ( %wecrm.gt.fr.searchword isin %wecrm.d.botecho ) {
      set %wecrm.gt.rtn $findtok(%wecrm.d.botecho,%wecrm.gt.fr.searchword,1,32)
      if (%wecrm.gt.rtn == $null) {
        set %wecrm.gt.rtn $pos(%wecrm.d.botecho,%wecrm.gt.fr.searchword)
        set %wecrm.gt.rtn $right(%wecrm.d.botecho,$calc( $len(%wecrm.d.botecho) - %wecrm.gt.rtn - $len(%wecrm.gt.fr.searchword) +1 ))
      }
      else {
        set %wecrm.gt.fr.c $calc($findtok(%wecrm.d.botecho, %wecrm.gt.fr.searchword , 1, 32) +1) $+ -
        set %wecrm.gt.rtn $gettok(%wecrm.d.botecho,%wecrm.gt.fr.c,32)
      }
      if ( %wecrm.gt.fr.i == 0 ) set %wecrm.gt.fr.i $numtok(%wecrm.gt.rtn,32)
      set %wecrm.gt.fr.c 1
      unset %wecrm.gt.fr.r
      while ( %wecrm.gt.fr.c <= %wecrm.gt.fr.i ) {
        if ( $gettok( %wecrm.gt.rtn, %wecrm.gt.fr.c, 32) isalnum ) set %wecrm.gt.fr.r %wecrm.gt.fr.r $+ . $+ $gettok( %wecrm.gt.rtn, %wecrm.gt.fr.c, 32)
        else {
          if ( %wecrm.gt.fr.c == 1 ) { set %wecrm.gt.fr.r %wecrm.gt.fr.r $+ . $+ $gettok( %wecrm.gt.rtn, %wecrm.gt.fr.c, 32) | break }
          set %wecrm.gt.fr.r %wecrm.gt.fr.r $+ .
          set %wecrm.gt.fr.tmp $gettok( %wecrm.gt.rtn, %wecrm.gt.fr.c, 32)
          while ( $left(%wecrm.gt.fr.tmp,1) isalnum ) {
            set %wecrm.gt.fr.rtmp %wecrm.gt.fr.rtmp $+ $left(%wecrm.gt.fr.tmp,1)
            set %wecrm.gt.fr.tmp $right(%wecrm.gt.fr.tmp,$calc($len(%wecrm.gt.fr.tmp)-1))
          }
          set %wecrm.gt.fr.c $readini %wecrm.ini nukeM nForbiddenendchars
          while ( $len(%wecrm.gt.fr.c) > 0 ) {
            if ( $left(%wecrm.gt.fr.tmp,1) == $right(%wecrm.gt.fr.c,1) ) break
            set %wecrm.gt.fr.c $left(%wecrm.gt.fr.c,$calc($len(%wecrm.gt.fr.c)-1))
          }
          if ( $len(%wecrm.gt.fr.c) == 0 ) set %wecrm.gt.fr.r %wecrm.gt.fr.r $+ %wecrm.gt.fr.rtmp
          break
        }
        inc %wecrm.gt.fr.c
      }
      if ( %wecrm.gt.fr.r == $null ) set %wecrm.gt.fr.r $gettok(%wecrm.gt.rtn,1,32)
      if ( $left(%wecrm.gt.fr.r,1) == . ) set %wecrm.gt.fr.r $right(%wecrm.gt.fr.r,$calc($len(%wecrm.gt.fr.r)-1))
      if ( $len(%wecrm.gt.fr.r) > 30 ) set %wecrm.gt.fr.r $left(%wecrm.gt.fr.r,30)
      if ( $right(%wecrm.gt.fr.r,1) !isalnum ) set %wecrm.gt.fr.r $left(%wecrm.gt.fr.r,$calc($len(%wecrm.gt.fr.r)-1))
      return %wecrm.gt.fr.r
    }
    inc %wecrm.gt.fr.tempc
    set %wecrm.gt.fr.searchword $readini %wecrm.ini nukeM $1
  }
  return unknown
}


;**> NUKEMONITOR WINDOW UPDATING >************
;=============================================
alias updatenukewindow {
  set %wecrm.gt.unw.nwl $ini(%wecrm.nukedb, NUKELIST, $1)
  set %wecrm.gt.unw.ln $ini(%wecrm.nukedb, NUKELIST, 0)

  if ( %wecrm.gt.unw.nwl == 0 ) {
    inc %wecrm.nonukes
    set %wecrm.gt.unw.dirname $gettok($line(@Nukemonitor,7,0),2,9)
    set %wecrm.gt.unw.dirinfo $readini %wecrm.nukedb NUKELIST %wecrm.gt.unw.dirname

    dline @Nukemonitor 7
    iline @Nukemonitor 3 $readini %wecrm.ini nukeM nMon_Last5

    if ($len(%wecrm.gt.unw.dirname) > 3) {
      $setnukevariables( %wecrm.gt.unw.dirname )
      iline @Nukemonitor 11 $readini %wecrm.ini nukeM nMon_hist
    }
    goto w_unl_end
  }

  set %wecrm.gt.unw.nwl $calc( %wecrm.gt.unw.ln - %wecrm.gt.unw.nwl + 1)

  if (( %wecrm.gt.unw.nwl <= %wecrm.nonukes ) && ( %wecrm.nonukes <= 5 )) { set %wecrm.gt.unw.tmpstr $readini %wecrm.ini nukeM nMon_Last5 }
  else { set %wecrm.gt.unw.tmpstr $readini %wecrm.ini nukeM nMon_hist }

  if ( %wecrm.nonukes <= 5 ) {
    if ( %wecrm.gt.unw.nwl <= %wecrm.nonukes ) inc %wecrm.gt.unw.nwl 2
    else inc %wecrm.gt.unw.nwl $calc( 10 - %wecrm.nonukes )
  }
  else {
    if ( %wecrm.gt.unw.nwl <= 5 ) inc %wecrm.gt.unw.nwl 2
    else inc %wecrm.gt.unw.nwl 5
  }
  rline @Nukemonitor %wecrm.gt.unw.nwl %wecrm.gt.unw.tmpstr
  :w_unl_end
  unset %wecrm.gt.unw.*
}



;**> INIT NUKEMONITOR WINDOW >***************
;============================================
alias initnukewindow {
  set %wecrm.nukemonrunning yes
  set %wecrm.nukelogging yes
  if ($window(@Nukemonitor) != @Nukemonitor) {
    set %wecrm.nonukes 0
    set %wecrm.nukedb $SCRIPTDIRnukedb.txt
    if ( $exists(%wecrm.nukedb) == $false ) write %wecrm.nukedb [NUKELIST]

    window -k0lr -t1,14,44 @Nukemonitor
    titlebar @Nukemonitor - Double click on a release to get more information
    aline @Nukemonitor --[ last 5 nukes ]------------------------------------ ---  --  -
    aline @Nukemonitor $chr(9)
    aline @Nukemonitor $chr(9)
    aline @Nukemonitor $chr(9)
    aline @Nukemonitor $chr(9)
    aline @Nukemonitor $chr(9)
    aline @Nukemonitor $chr(9)
    aline @Nukemonitor $chr(9)
    aline @Nukemonitor --[ history ]--------------------------------------- ----  -    -
    aline @Nukemonitor $chr(9)

    set %wecrm.gt.inw.looptimes $ini(%wecrm.nukedb, NUKELIST,0)
    set %wecrm.gt.inw.starttime $calc($ctime - ( $ticks / 1000 ))
    while ( %wecrm.gt.inw.looptimes > 0 ) {
      set %wecrm.gt.inw.inw.dirname $ini(%wecrm.nukedb, NUKELIST, %wecrm.gt.inw.looptimes)
      $setnukevariables( %wecrm.gt.inw.inw.dirname )
      if ( %wecrm.nonukes < 5 ) && ( $calc(%wecrm.n.ctime - %wecrm.gt.inw.starttime) > 0 ) {
        rline @Nukemonitor $calc(3 + %wecrm.nonukes) $readini %wecrm.ini nukeM nMon_last5
        inc %wecrm.nonukes
      }
      else aline @Nukemonitor $readini %wecrm.ini nukeM nMon_hist
      dec %wecrm.gt.inw.looptimes
    }
  }
}


on 1:CLOSE:@Nukemonitor {
  set %wecrm.nonukes 0
  set %wecrm.nukemonrunning no
  set %wecrm.nukelogging $getsel_wecrm(nukeM nLogging)
}


;###[ FUNCTION WICH TOGGLES SETTING $2 IN BLOCK $1 TO $3 IF $3 IS A VALID
;###[ SETTING SEE WECRM.DAT TO UNDERSTUND IT BETTER ...
alias toggle {
  set %wecrmtmp.toggle $readini %wecrm.ini $1 $2
  set %wecrmtmp.toggle $deltok(%wecrmtmp.toggle,1,32)
  if ($findtok(%wecrmtmp.toggle,$3,1,95) > 0) {
    writeini %wecrm.ini $1 $2 $3 %wecrmtmp.toggle
    echo -a $wecrmprefix $chr(91) $+ $1 $+ $chr(93) $+ -> $+ $2 now set to $3
  }
  else { 
    set %wecrmtmp.toggle $replace(%wecrmtmp.toggle,_,$chr(32))
    echo -a $wecrmprefix $chr(91) $+ $1 $+ $chr(93) $+ -> $+ $2 valid options are: %wecrmtmp.toggle
  }
  set %wecrm.gt.toggle $2 $+ $3
  $readini %wecrm.ini toggle %wecrm.gt.toggle
  if (%wecrm.ddemode == yes) {
      flushini %wecrm.ini
      dde %wecrm.ddename command "" /wecrm_reload
  }
  setcriticalvariables_wecrm
  unset %wecrmtmp.toggle
}

alias selectwave {
  set %wecrm.gt.wavefile $file="Select a file to play upon new release" c:\*.*
  if ( %wecrm.gt.wavefile != $null ) writeini %wecrm.ini wecrm beepwave %wecrm.gt.wavefile
  else {
    echo -a $wecrmprefix Yeah right.. I select YES for you until you get smarter
    $toggle(wecRM,beep,yes)
  }
}

alias cvlview {
  set %cvl.dir $1
  set %cvl.looptimes $ini(%cvl.dir,$2,0)

  window -alk0st0,12 [ @wecRM- ] $+ [ $2 ] 350 20 280 400
  set %cvl.i 1
  while (%cvl.i <= %cvl.looptimes) {
    aline [ @wecRM- ] $+ [ $2 ] $ini(%cvl.dir,$2,%cvl.i) $chr(9) $readini -n %cvl.dir $2 $ini(%cvl.dir,$2,%cvl.i)
    inc %cvl.i
  }

  unset %cvl.*
}

alias cvlset {
  ; $1 filename, $2 section, $3 item, $4 0/1 (1 is cant be removed), $5 0/1 (1 is numbers only)
  set %cvl.presites $readini $1 $$2 $$3
  set %cvl.answer $?="Current setting for $3 = %cvl.presites $crlf $crlf $+ To leave unchanged press enter $crlf $+ To remove only type '-'"
  if (%cvl.answer == -) {
    if (%cvl.presites != $null) {
      if ($4 == 1) { echo -a $wecrmprefix $chr(91) $+ $2 $+ $chr(93) $+ -> $+ $3 this setting cannot be removed! | goto cvlset_end }
      remini $1 $2 $3
      flushini $1
      echo -a $wecrmprefix $chr(91) $+ $2 $+ $chr(93) $+ -> $+ $3 removed.
    }
  }
  elseif ((%cvl.answer != %cvl.presites) && (%cvl.answer != $null)) {
    if ($5 == 1) && (%cvl.answer !isnum) { echo -a $wecrmprefix $chr(91) $+ $2 $+ $chr(93) $+ -> $+ $3 only a number is a valid setting! | goto cvlset_end }
    writeini $1 $2 $3 %cvl.answer
    flushini $1
    echo -a $wecrmprefix $chr(91) $+ $2 $+ $chr(93) $+ -> $+ $3 now set to %cvl.answer
  }
  else {
    if (%cvl.presites != $null) {
      echo -a $wecrmprefix $chr(91) $+ $2 $+ $chr(93) $+ -> $+ $3 no change done
    }
  }
  if (%wecrm.ddemode == yes) { dde %wecrm.ddename command "" /wecrm_reload }
  :cvlset_end
}

dialog nukemonitornote {
  title "Nukemonitor note!"
  text "In order to log releases while this window is closed you have to set nukelogging on",2, 10 15 230 60 , center
  size -1 -1 250 120 
  button "OK",1,100 70 50 30 , OK  
}

alias wecrm_dde_newrelease {
   set %wecrm.dirname $1
   set %wecrm.d.dirname $2
   set %wecrm.d.sitename $3
   set %wecrm.dupesitelist $4
   set %wecrm.d.presites $5-
   set %wecrm.olddirname %wecrm.lastdirname
   set %wecrm.lastdirname %wecrm.dirname
   display NEW_RELEASE
   if (%wecrm.noracemode == no) { display NEW_RACE_RELEASE | set %wecrm.rtime $ctime | set %wecrm.rcounter 2 }   
}

alias wecrm_dde_racerelease {
   set %wecrm.dupesitelist %wecrm.dupesitelist $1
   set %wecrm.d.sitename $2-
   display RACE_RELEASE
   inc %wecrm.rcounter
}


alias wecrm_dde_warning {
   set %wecrm.d.wb $1
   set %wecrm.d.wb_msg $2-
   display WARNING
}

alias wecrm_dde_nukewarning {
   set %wecrm.d.botecho $1-
   display NUKEWARNING
}

alias wecrm_dde_setxtime {
   set %wecrm.x $1
}

alias wecrm_dde_xtimeout {
   timerwecRMXmodeto off
}

alias wecrm_dde_unw {
      $updatenukewindow( $1 )
}

alias wecrm_dde_clipboardyes {
   if ($appactive) clipboard $1
}

alias fixircn {
  set %h [12N]
  set %c2 12
  set %c3 14
  set %c4 04
}
